% Fig 5-33
clear all ;% clear all variables
close all
%================================
BitRate = 2.5e9;  

R =1; %[A/W]

k=1.38e-23;
q=1.6e-19;
T = 300;
Fn=2;
RL = 10e3;

Be=0.7*BitRate;

%================================
P1 = -46:.2:-25; %[dBm]

P1_lin = 1e-3*10.^(P1/10); %[W]

rex = 0;

P0_lin = rex*P1_lin; %[W]

Pavg = (P1_lin+P0_lin)/2; Pavg_dBm = 10*log10(Pavg*1e3);

% ==for PIN =======
I1 = R*P1_lin; I0 = R*P0_lin;

var_th=4*k*T*Be*Fn/RL;

var1 =2*q*I1*Be + var_th; var0 =2*q*I0*Be + var_th;

Q_pin = (I1-I0)./(sqrt(var1)+sqrt(var0));

ber_pin = 0.5*erfc(Q_pin./sqrt(2));

clear I1 I0 var1 var2
%========================================
% ==for APD =======
M=8.5; ka=0.6; Fa=ka*M+(1-ka)*(2-1/M);


I1 = M*R*P1_lin; I0 = M*R*P0_lin;

var1 =2*q*M*Fa*I1*Be + var_th; var0 =2*q*M*Fa*I0*Be + var_th;

Q_apd = (I1-I0)./(sqrt(var1)+sqrt(var0));

ber_apd = 0.5*erfc(Q_apd./sqrt(2));

%========================================
%
figure(1)

%semilogy(Pavg_dBm,ber_pin, Pavg_dBm,ber_apd,'r-.'  ); 

log_berpin = log10(ber_pin); log_berapd = log10(ber_apd);
semilogy(Pavg_dBm,log_berpin, Pavg_dBm,log_berapd,'r-.'  ); 

xlabel('P_i_n[dBm]', 'FontSize', 16), ylabel('log(BER)', 'FontSize', 16), title('R_b=2.5Gb/s', 'FontSize', 16)
%axis([-48 -30 1e-20 1])
axis([-45 -30 -25 -2.5])

grid on
%========================================

